Create repository

This commit is contained in:
Loic Guegan 2021-04-04 11:19:55 +02:00
commit 2a99c6259d
11 changed files with 191 additions and 0 deletions

1
.gitignore vendored Normal file
View file

@ -0,0 +1 @@
**/*.o

10
Makefile Normal file
View file

@ -0,0 +1,10 @@
all:
@printf "Usage:\n"
@printf "%25s %s\n" "Compile kernel:" "make kernel"
qemu:
make -C src/
qemu-system-i386 -kernel src/bringelle

0
README.md Normal file
View file

30
src/Makefile Normal file
View file

@ -0,0 +1,30 @@
EXEC := bringelle
CC := gcc -c -m32 -fno-pie -fno-builtin
UTILS_SRC := $(wildcard utils/*.c)
all: $(EXEC)
$(EXEC): boot.o utils.o bringelle.o
for obj in $^ ;\
do \
objcopy --remove-section .note.gnu.property $${obj} ; \
done
ld -Ttext=0x00100000 -melf_i386 -nostdlib --oformat=binary -o bringelle $^
bringelle.o: bringelle.c
$(CC) $^
utils.o: $(UTILS_SRC)
$(CC) $^ -o $@
boot.o: ./boot/boot.S
as --32 -o $@ $^ -mx86-used-note=no
clean:
- rm $(EXEC)
- rm ./*.o
.PHONY: clean

27
src/boot/boot.S Normal file
View file

@ -0,0 +1,27 @@
.extern bringelle
.globl _start
.text
.set MB_MAGIC, 0x1BADB002
.set MB_FLAGS, 0x00010000
.set MB_CHECKSUM, -(MB_MAGIC+MB_FLAGS)
.set MB_HEADER_ADDR, mb_header
.set MB_LOAD_ADDR, mb_header
.set MB_LOAD_END_ADDR, 0x0
.set MB_BSS_END_ADDR, 0x0
.set MB_ENTRY_ADDR, _start
mb_header:
.align 4
.long MB_MAGIC
.long MB_FLAGS
.long MB_CHECKSUM
.long MB_HEADER_ADDR
.long MB_LOAD_ADDR
.long MB_LOAD_END_ADDR
.long MB_BSS_END_ADDR
.long MB_ENTRY_ADDR
_start:
call bringelle

BIN
src/bringelle Executable file

Binary file not shown.

11
src/bringelle.c Normal file
View file

@ -0,0 +1,11 @@
#include "utils/print.h"
void bringelle(){
putchar('L');
putchar('L');
while(1);
}

7
src/utils/print.c Normal file
View file

@ -0,0 +1,7 @@
#include "print.h"
void putchar(char c){
char *video=(char *)0xB8000;
video[0]=c;
}

7
src/utils/print.h Normal file
View file

@ -0,0 +1,7 @@
#ifndef PRINT_H
#define PRINT_H
void putchar(char);
#endif

62
tools/gen_syslinux_floppy.sh Executable file
View file

@ -0,0 +1,62 @@
#!/usr/bin/env bash
# Ensure to abort on error
set -e
wai=$(dirname $(readlink -f "$0")) # Current script directory
outdir="${wai}/../"
floppy="${outdir}/floppy.img"
mountp="$(mktemp -d)" # Mount point (where the floppy will be mounted temporally
sysbios="/usr/lib/syslinux/bios/" # Syslinux bios and ui locations
check_for () {
command -v "$1" &>/dev/null || { echo "Command $1 not found!"; exit 1; }
}
check_for parted
check_for losetup
check_for extlinux
check_for mkfs.ext4
[ -d "$sysbios" ] || { echo "Syslinux bios \"$sysbios\" not found!"; exit 1; }
# Create drive
dd if=/dev/zero of=${floppy} bs=512 count=50000 # Change count to change floppy size :)
parted -s $floppy mklabel gpt
parted -s $floppy mkpart linux ext4 0 100%
parted -s $floppy set 1 legacy_boot on # Require for syslinux according to https://wiki.gentoo.org/wiki/Syslinux#GPT
# Initiate loop devices
loop=$(sudo losetup -f)
part="${loop}p1" # Disk partition
sudo losetup -Pf $floppy
# Prepare disk partition
sudo mkfs.ext4 $part
sudo mount $part "$mountp"
sudo mkdir -p $mountp/boot/syslinux/
# Configuring syslinux
sudo chown -R loic $mountp/boot/
cfg=$(mktemp)
cat > "$cfg" <<EOF
TIMEOUT 30
UI vesamenu.c32
MENU TITLE Syslinux
LABEL Bringelle
KERNEL /boot/bringelle.bs
EOF
mv "$cfg" "$mountp/boot/syslinux/syslinux.cfg"
cp $sysbios/*.c32 $mountp/boot/syslinux/
sudo extlinux --install $mountp/boot/syslinux
# Umount floppy
sync
sudo umount "$mountp"
rmdir "$mountp"
# Install MBR
sudo dd bs=440 count=1 conv=notrunc if=$sysbios/gptmbr.bin of=${loop}
# Cleanup
sudo losetup -D

36
tools/load_bringelle.sh Executable file
View file

@ -0,0 +1,36 @@
#!/usr/bin/env bash
# Ensure to abort on error
set -e
wai=$(dirname $(readlink -f "$0")) # Current script directory
outdir="${wai}/../"
floppy="${outdir}/floppy.img"
mountp="$(mktemp -d)" # Mount point (where the floppy will be mounted temporally
kernel="${outdir}/src/bringelle"
check_for () {
command -v "$1" &>/dev/null || { echo "Command $1 not found!"; exit 1; }
}
check_for losetup
[ ! -e "$floppy" ] && { echo "Floppy drive \"$floppy\" not found!"; exit 1; }
[ ! -e "$kernel" ] && { echo "Kernel \"$kernel\" not found!"; exit 1; }
# Initiate loop devices
loop=$(sudo losetup -f)
part="${loop}p1" # Disk partition
sudo losetup -Pf $floppy
# Prepare disk partition
sudo mount $part "$mountp"
cp $kernel $mountp/boot/bringelle.bs
# Umount floppy
sync
sudo umount "$mountp"
rmdir "$mountp"
# Cleanup
sudo losetup -D